;---------------------------------------------------------
;	Centralka alarmowa z wyswietlaczem LED
;		15 linii  typ CA 20
;---------------------------------------------------------




	#include "p12C508A.INC"
	LIST p=12C508A





GP0	  equ 	00	; Ozn. portow	
GP1       equ 	01
GP2	  equ 	02
GP3	  equ 	03
GP4	  equ 	04
GP5	  equ 	05

DLY_FLAG  equ 	01	; Flaga dla linii opozniajacej, ust. przy uaktywnieniu linii
			; umozliwia przejscie z LOOP do alarmu po okreslonym czasie.

A_SW	  equ 	02	; Flaga przyc. alarmu i antysabotazu ( ust.umozliwia spr.
			; przyciskow w LOOP za pomoca instrukcji skoku. 
			;   Procedura linii  opozniajacej musi zerowac flage,
			; poniewaz LOOP musi umozliwic jej odliczanie i wyswietlanie 
			; czasu, po ktorym wyst.alarm 

P_FLAG	 equ	03	; Flaga zezwala na wyswietlanie kropki   
Over	 equ	04	; Flaga ' KONIEC ALARMU '			   

R_FLAG	 equ  	07	; Rej. flag



LIR_1	 equ  	08	; Rejestry wskaznikow identyfikacji linii, 
LIR_2	 equ  	09	; ustawiane sa na stale przy naruszeniu linii

			;         ----------------------------------------------
			; LIR_1  | L8  | L7  | L6  | L5  | L4  | L3  | L2  | L1 |
			;	  ----------------------------------------------
			; LIR_2  |  -  | AS  | L14 | L13 | L12 | L11 | L10 | L9 |
			;	  ----------------------------------------------
L1	 equ  	0
L2	 equ  	1
L3	 equ  	2
L4	 equ  	3	; wskazniki linii 
L5	 equ  	4
L6	 equ  	5
L7	 equ  	6
L8	 equ  	7
L9	 equ  	0
L10	 equ  	1
L11	 equ  	2
L12	 equ  	3
L13	 equ  	4
L14	 equ  	5
AS	 equ  	6	; wsk. przyc. alarm

 


R_adr	equ	0A	; rejestr adresowy linii
;		0B
R_point	equ	0C	; rejestr kropki
;		0D	; licznik
;		0E      ; licznik
Disp	equ	0F	; rej. adresowy linii wpr. na wyswietlacz
;		10
;		11
;		12  
;		15	
;		

;	      	16	liczn. przyc. alarmu i antysabotazowego
   
	
REG_P	 equ 	17
CONFIG	 equ 	18	; rej. konfiguuracji timera zawiera czas opoznienia alarmu


TEMP_1	 equ 	19	; rej. wart. chwilowych
TEMP_2	 equ 	1A



BYTE	 equ 	1B	; licznik transmitowanych bajtow
BIT	 equ 	1C	; licznik transmitowanych bitow	
DRV	 equ 	1F	; rejestr sterujacy i adresowy
MSD 	 equ 	1D	; rej. 1 cyfry wyswietlacza
LSD 	 equ 	1E	; rej. 2 cyfry wyswietlacza






;---------------------------------------------------------

	

	org 1FF
	
 	movlw 	H'9C'	; laduj do akum. wart. kalibr. wewn. oscylatora


	org 	00
	movwf 	OSCCAL	; wprowadz wart. kal. do rejestru OSCCAL

	goto	START

;------------------------------------------------------------------
;			8 bit na BCD
;------------------------------------------------------------------



BinBCD 
	clrf    MSD
	movwf   LSD
gtenth  movlw   .10
	subwf   LSD,W
	BTFSS   STATUS,C
	goto    OVER
	movwf   LSD
	incf    MSD, F
	goto    gtenth
	

;-------------------------------------------------------------------
;		Konwersja BCD na kod 7-seg. 
;-------------------------------------------------------------------

OVER
	
	movf	MSD,W
	bcf	STATUS,Z	;
	xorlw	00		; proc. likwiduje wyswietlanie	
	btfsc	STATUS,Z	; pierwszej cyfry zero	
	goto	PASS		;
	call 	CONVERT
PASS	movwf	MSD
	movwf	11		; rej.podtrzymujacy wynik
	movf 	LSD,W
	call 	CONVERT
	iorwf	R_point,W	; zapala dodatko kropke
	movwf	LSD
	movwf	12		; rej. podtrzymujacy wynik
	goto 	SERIAL


CONVERT
	addwf	PCL,F
	
	retlw	B'00111111'	; 0
	retlw	B'00000110'	; 1
	retlw	B'01011011'	; 2
	retlw	B'01001111'	; 3
	retlw	B'01100110'	; 4
	retlw	B'01101101'	; 5
	retlw	B'01111101'	; 6
	retlw 	B'00000111'	; 7
	retlw 	B'01111111'	; 8
	retlw 	B'01101111'	; 9


;--------------------------------------------------------
;		Transmisja szeregowa
;--------------------------------------------------------



;		-----------------
;		| 1D | DATA_1	|	REJ. WYSWIETLACZA 1-CYFRA
;		-----------------
;		| 1E | DATA_2   |	REJ. WYSWIETLACZA 2-CYFRA
;		-----------------
;		| 1F | DATA_3   |	REJ. ADRESOWY MUTIPLEKSERA + WYJ. STERUJACE
;		-----------------

SERIAL
	
	movlw	03	; trzy bajty do transmisji
	movwf	BYTE
	movlw	1D	; adres pierwszego bajtu
	movwf	FSR

TX
	clrf	GPIO	
	movlw	08
	movwf	BIT	; licznik bitow
DO
	bcf	STATUS,C		
	rlf	INDF,F	
	btfss	STATUS,C	
	goto	ZERO		; ustaw	0 do transmisji
	bsf	GPIO,GP4	; ustaw 1 do transmisji	
WRITE
	bsf	GPIO,GP2	; ___----		wpisz bit			
	bcf	GPIO,GP2	;	  ----____   
	decfsz	BIT,F
	goto	DO
	incf	FSR,F		; nastepny bajt
	decfsz	BYTE,F		; licznik bajtow - 1
	goto	TX
	bsf	GPIO,GP5	; strobuj dane
	bcf	GPIO,GP5	;		__----__
	retlw	0
ZERO
	bcf	GPIO,GP4
	goto	WRITE



;---------------------------------------------------------------
;		Dekoduj wskaznik naruszenia linii
;---------------------------------------------------------------

Dt_LR			; Procedura dekoduje numer rej. LIR,
			; przeszukuje wskazniki i dekoduje adres
			; danego wskaznika, ktory ma byc nastepnie
	movlw .16	; wyswietlony jako numer linii. 
	movwf R_adr
DF	decfsz R_adr,F
	goto L
	retlw 0

L	movf LIR_1,W
	movwf TEMP_1
	movf LIR_2,W
	movwf TEMP_2

	
	incf Disp,F	
;--------------------------
	movf Disp,W
	bcf   STATUS,Z
	xorlw .15	; Czy  ostatni adres byl ustawiony ?
	btfsc STATUS,Z
	clrf Disp	; TAK !	
  
;--------------------------

	bcf STATUS,C 			
	movlw .8
	subwf Disp,W
	btfsc STATUS,C
	goto LR2


LR1

	movf Disp,W
	movwf 015
	incf 015,F
RRF_1	bcf STATUS,C
	rrf TEMP_1,F
	decfsz 015,F
	goto RRF_1
	goto CHK_StC		
		
LR2
	

	movwf 015
	incf 015,F
	bcf STATUS,C
RRF_2	rrf TEMP_2,F
	decfsz 015,F
	goto RRF_2


CHK_StC
	
		
	btfss STATUS,C
	goto DF	

	retlw 0	


;---------------------------------------------------------------------
;			SPRAWDZAJ LINIE
;---------------------------------------------------------------------


; Przyciski musza byc wcisniete dluzej niz 0.1 sek. zeby byly rozpoznane.
; To zabezpiecza przed ewentualnymi zakloceniami i  wydluzaniem czasu 
; trwania alarmu.
 
	
SEARCH	
	clrwdt
	movlw .05
	movwf 0E	; inicjowanie timera 0.5 sek.


LOAD_D
	movlw .20
	movwf 0D

	clrf TEMP_1
	clrf TEMP_2
	comf TEMP_1,F
	comf TEMP_2,F 

BEG_adr
	clrf R_adr

Set_adr

	movf R_adr,W	
	iorwf 0B,W
	movwf DRV
	movf 11,W
	movwf MSD
	movf 12,W
	btfsc R_FLAG,P_FLAG
	iorwf R_point,W
	movwf LSD
	
	call SERIAL
	btfss GPIO,GP3			
	goto ClsTEMP

Ret
	incf R_adr,F
	movf  R_adr,W	
	bcf   STATUS,Z
	xorlw .14	; Czy  ostatni adres byl ustawiony ?
	btfss STATUS,Z
	goto  Set_adr	; NIE : ustaw adres, spr. linie i wez nast.  

	 		   		    
                         
	btfsc  GPIO,GP1	 ; spr. przycisk alarmu
	bcf TEMP_2,AS

	decfsz 0D,F
	goto BEG_adr
;----------------------------------------------------------------------
	clrw		; Czy ustawic od pocz. licznik 5 min ?
	bcf STATUS,Z
	xorwf TEMP_1,W
	btfss STATUS,Z
	goto SD_5min
	bcf TEMP_2,7

	bcf STATUS,Z
	xorwf TEMP_2,W
	btfss STATUS,Z	
	goto SD_5min		

;----------------------------------------------------------------------

RD_TEMP			; Czy adres w Disp ma wskaznik w TEMP
			; Procedura umozliwia identyfikacje otwarcia
			; linii poprzez wyswietlanie kropki 

	bcf STATUS,C 	; dekoduj rejestr TEMP		
	movlw .8	;
	subwf Disp,W
	btfsc STATUS,C
	goto R_TMP2


R_TMP1

	movf Disp,W
	movwf 015
	incf 015,F
	call Tab_ind
	andwf TEMP_1,W
	movwf 016
	
SUB_1	bcf STATUS,C
	rrf 016,F
	decfsz 015,F
	goto SUB_1
	btfsc STATUS,C 	;     Czy wyswietlac kropke ?
	bsf R_point,7	;        TAK ! ustaw  bit w  rej.kropki		
	goto WR_TtoL
		
R_TMP2
	movwf 015
	incf 015,F
	call Tab_ind
	andwf TEMP_2,W
	movwf 016

SUB_2	bcf STATUS,C
	rrf 016,F
	decfsz 015,F
	goto SUB_2
	btfsc STATUS,C
	bsf R_point,7		
		
WR_TtoL	
	movf TEMP_1,W
	iorwf LIR_1,F
	movf TEMP_2,W
	iorwf LIR_2,F

	decfsz 0E,F	; zmniejsz licznik '0.5 sek'
	goto LOAD_D
	retlw 0

;---------------------------------------------------------------------
;		Detekcja rejestrow LIR_1 i LIR_2 
;---------------------------------------------------------------------


DtcLIR			; ustawia wskazniki naruszenia 14 linii 
			; i przycisku alarmu w dwoch rejestrach
			; LIR_1 i LIR_2. Wsk. sa ustawiane trwale
			; i sa wyswietlane kolejno w postaci numeru
			; linii
	bcf STATUS,C
	movlw .8
	subwf R_adr,W
	btfsc STATUS,C
	goto D_LIR2


D_LIR1

	movf R_adr,W
	call Tab_ind
	iorwf LIR_1,F
	
	retlw 0
	
D_LIR2

	call Tab_ind
	iorwf LIR_2,F
	
	retlw 0		

Tab_ind
	addwf PCL,F

	retlw B'00000001'
	retlw B'00000010'
	retlw B'00000100'
	retlw B'00001000'
	retlw B'00010000'
	retlw B'00100000'
	retlw B'01000000'
	retlw B'10000000'

;-----------------------------------------------------

GetTime			; tabela opoznien wl. alarmu

	addwf PCL,F

	retlw	.20 ;	sek.	
	retlw	.45 ;	sek.
	retlw	.60 ;	sek.
	retlw	.90 ;	sek.	


;------------------------------------------------------
;		Poczatek programu		
;------------------------------------------------------

START

	


	movlw 	D'24'
	movwf 	07	; zeruj RAM
	movlw 	08
	movwf 	FSR
NEXT	clrf 	INDF
	incf 	FSR,F			 
	decfsz 	07,F
	goto 	NEXT


;------------------------------------------------------------------

			; inicjuj linie portow   GP0,GP1,GP3 wejscia
			;			 GP2,GP4,GP5 wyjscia
			; timer TMR0 1:256

	movlw 	B'10000111'
	option
	movlw 	B'000001011'
	tris 	GPIO
	



	movlw  .22	; ust.licznika przyc. alarmowego
	movwf  REG_P	; i antysabotazowego



			; odczyt ustawien timera 
			; 2 bity wpisywane do CONFIG
			
	movlw  D'14'	; ustaw adres 14	
	movwf  DRV
	call   SERIAL
	btfss  GPIO,GP3	; spr. ustawienie DIP
	goto   GO_N
	bsf    CONFIG,1
GO_N
	movlw  D'15'	; ustaw adres 15
	movwf  DRV
	call   SERIAL
	btfss  GPIO,GP3 ; spr. ustawienie DIP
	goto   SEND
	bsf    CONFIG,0


;-------------------------------------------------------
	
SEND		
	movf  CONFIG,W
	call  GetTime
	movwf CONFIG	; zapisz ust. w CONFIG
DLY_t	movwf TEMP_1	; i w TEMP_1 
	call  BinBCD 	; wyswietl czas opoznienia

	
TIME

	movlw  .16	; inicj. timer 1 sek.
	movwf  TEMP_2
LOAD	movlw  10
	movwf  TMR0




;-------------------------------------------------------


LOOP
	clrwdt
			 ; spr. przyciskow : antysabotazowego,
	btfsc  GPIO,GP0	 ;		    i alarmowego		    
	goto   CHK_T1	 ; przez ok. 50 msek. (czas petli 9 usek.)
	btfss  GPIO,GP1
	goto   CHK_T
	clrf   16
	movlw .22
	movwf  REG_P
	btfsc  R_FLAG,A_SW
	goto   MAIN_2

;-------------------------------------------------------

LOOP_C	bcf    STATUS,Z
	movlw  00
	addwf  TMR0,W
	btfss  STATUS,Z	
	goto   LOOP
	decfsz TEMP_2,F
	goto   LOAD
	decf   TEMP_1,F
	movf   TEMP_1,W
	bcf    STATUS,Z
	xorlw  00		; odliczanie konczy sie na 1
	btfsc  STATUS,Z
	goto   MAIN
	movf   TEMP_1,W
	call   BinBCD
	clrf 11
	clrf 12
	goto   TIME

CHK_T1
	nop
	nop
CHK_T
	incfsz  16,F
	goto    LOOP
	decfsz  REG_P,F
	goto    LOOP
	goto    ALARM_S
		
	


	
;-----------------------------------------------------

MAIN
	movlw 	B'10000111'
	option

	btfsc   R_FLAG,DLY_FLAG
	goto    ALARM

MAIN_1

	bsf    R_FLAG,A_SW		; spr. przyc. alarm i sabotaz
	goto   LOOP			; w LOOP
MAIN_2
	clrf   15			; zeruj rej. adresowy multipleksera

INC_adr
	clrwdt
;-----------------------------------------------------

	movlw   .59	; inicj. timer 0.2 sek.
	movwf   TMR0
	movlw   .4
	movwf   TEMP_2	

;-----------------------------------------------------

	movf   15,W
	movwf  DRV
	movf   11,W
	movwf  MSD
	movf   12,W
	movwf  LSD
	call   SERIAL
CHK_K	
	movlw  .59	; laduj timer wart. poczatkowa 0.2 sek.
	movwf  TMR0

CHK_L
	clrwdt
	btfss  GPIO,GP3
	goto   N_line
	bcf    STATUS,Z
	movlw  00
	addwf  TMR0,W
	btfss  STATUS,Z	
	goto   CHK_L
	decfsz TEMP_2,F
	goto   CHK_K

;----------------------------------------------------


	clrw		; detekcja linii opozniajacej
	bcf   STATUS,Z	; nr 1 ( adres: 0000 )
	subwf 15,W
	btfsc STATUS,Z
	goto  DLY_SET
	goto  ALARM


;-----------------------------------------------------

			
N_line			;  ust. adresu nast. linii
			;  ( 14 linii adr. od 0 do .13)
	incf  15,F	
	movf  15,W
	bcf   STATUS,Z
	xorlw .14		; Czy  ostatni adres byl ustawiony ?
	btfss STATUS,Z
	goto  INC_adr		; NIE : ustaw adres, spr. linie i wez nast.  
	btfss R_FLAG,Over	
	goto  MAIN_1		; TAK : powtarzaj procedure od poczatku.
	goto DispLN
;-----------------------------------------------------


DLY_SET

	bsf   R_FLAG,DLY_FLAG
	movf  CONFIG,W
	bcf   R_FLAG,A_SW
	goto  DLY_t



ALARM_S				; alarm inicjowany przez przycisk
				; alarmu

	movlw  .14
	movwf	R_adr
	movwf Disp
	call DtcLIR
	goto LD_5min



ALARM				; alarm inicjowany przez linie

	movf 015,W
	movwf R_adr
	movwf Disp
	call DtcLIR

LD_5min
	movlw .152		; Laduj timer wart. okr. czas trwania alarmu
	movwf REG_P		; ok. 5 min.

	bcf R_FLAG,Over		; Zeruj flage ' KONIEC ALARMU  '
	bcf R_FLAG,DLY_FLAG	; i opoznienia

CLR_H
	clrf 11
	clrf 12

SET_C	


	movlw 	B'10001111'
	option
				; ustawia wyjscie stale,
	movlw B'10000000'	; bit zost. ust. w najblizszej proc. SEARCH
	movwf 0B		; Rej.bedzie przechowywal ta wart.
				; dla kolejnych operacji
	movwf DRV
	 
	call SEARCH		; sprawdzaj linie
				



;---------------------------------------------------------------

	



	bsf 0B,6		; ustaw wyjscie impulsowe ( 11000000)
	bcf STATUS,Z
	movlw .14
	xorwf Disp,W		; Czy alarm wywolal przycisk alarmu ?
	btfsc STATUS,Z
	goto CH_V
	incf Disp,W		; Nr wyswietlanej linii  musi byc o jeden wiekszy
				; niz jej adres
	call BinBCD		; wyswietl numer

SEK_1.5
	bsf R_FLAG,P_FLAG	; zezwol na wyswietlanie kropki

	call SEARCH
	call SEARCH
	call SEARCH
	call Dt_LR

	bcf R_FLAG,P_FLAG	
	clrf R_point

	decfsz REG_P,F		; Czy minelo 5 min.
	goto CLR_H		;	NIE !
;------------------------------------------------------------
				;	TAK !

	bsf R_FLAG,Over		; Ustaw flage ' KONIEC ALARMU '	
	
	clrf DRV		; zeruj wyj. sterujace

	bcf STATUS,Z
	movlw .14
	xorwf Disp,W		; Czy alarm wywolal przycisk alarmu ?
	btfsc STATUS,Z		;	
	goto CH_V		;		Tak !
	incf Disp,W
			
	call BinBCD		; wyswietl numer



	movlw .201
	movwf 0D 	
DispLN
	decfsz 0D,F	
	goto MAIN
	
	movlw .200
	movwf 0D 

	call Dt_LR




	clrf DRV		; zeruj wyj. sterujace

	bcf STATUS,Z
	movlw .14
	xorwf Disp,W		; Czy alarm wywolal przycisk alarmu ?
	btfsc STATUS,Z		;	
	goto CH_V		;		Tak !

	incf Disp,W		
	call BinBCD		; wyswietl numer
	goto MAIN	


;------------------------------------------------------------


CH_V
	movlw B'01110111'	; A
	movwf MSD
	movwf 11
	movlw B'00111000'	; L
	movwf LSD
	movwf 12
	call SERIAL
	btfss R_FLAG,Over
	goto SEK_1.5
	goto MAIN
	




	
;-------------------------------------------------------------

ClsTEMP



	bcf STATUS,C 	; dekoduje rejestr TEMP		
	movlw .8
	subwf R_adr,W
	btfsc STATUS,C
	goto C_TMP2


C_TMP1

	movf R_adr,W
	call Tab_ind
	movwf 016
	comf 016,W
	andwf TEMP_1,F
	
	goto Ret
	
C_TMP2

	call Tab_ind
	movwf 016
	comf 016,W
	andwf TEMP_2,F
	
	goto Ret
;--------------------------------------------------------------

SD_5min			; laduje licznik 5 min. wart. poczotkowa
	movlw .152	; podczas alarmu gdy naruszy sie linie
	movwf REG_P
	goto RD_TEMP 

;--------------------------------------------------------------		
	
	



	

	end
